/* -------------------------------------------------------------------- */
/* snpp-server.c							*/
/*									*/
/*									*/
/* Copyright (C) 1997 Angelo Masci					*/
/*       								*/
/* This program is free software; you can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 2 of the License, or	*/
/* (at your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details.				*/
/*									*/
/* You should have received a copy of the GNU General Public License	*/
/* along with this program; if not, write to the Free Software		*/
/* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/
/* 									*/
/*  You can contact the author at this e-mail address:			*/
/*									*/
/*  angelo@styx.demon.co.uk						*/
/*									*/
/* --------------------------------------------------------------------
   $Id$
   -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "server.h"

/* -------------------------------------------------------------------- */

#define ERROR_STATE	-2
#define EXIT_STATE	-1
#define LOGIN_STATE	0
#define PAGE_STATE 	1
#define MESSAGE_STATE	2
#define SEND_STATE	3
#define HELP_STATE	4

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void gateway(int new_fd)
{
	char	buf[MAX_STRING_LEN],
		host_name[512],
		ip_address[512];

	int 	state;


	if (get_client_information(new_fd, host_name, ip_address) == 0)
	{	fprintf(stderr, "Connection from %s [%s]\n", host_name, ip_address);
	}


	hprintf(new_fd, "220 SNPP Gateway Ready\n", buf);

	state = LOGIN_STATE;
	while ((state != EXIT_STATE) &&
	       (state != ERROR_STATE) &&
	       (hgets(buf, MAX_STRING_LEN, new_fd) != NULL))
	{
		if (strncmp(buf, "PAGE", 4) == 0)
		{
			if (state == LOGIN_STATE)
			{
				hprintf(new_fd, "250 Pager ID Accepted\n");
				state = PAGE_STATE;
			}
			else
			{	state = ERROR_STATE;
			}
		}
		else
		if (strncmp(buf, "MESS", 4) == 0)
		{
			if (state == PAGE_STATE)
			{
				hprintf(new_fd, "250 Message OK\n");
				state = MESSAGE_STATE;
			}
			else
			{	state = ERROR_STATE;
			}
		}
		else
		if (strncmp(buf, "SEND", 4) == 0)
		{	
			if (state == MESSAGE_STATE)
			{
				hprintf(new_fd, "250 Message Sent Successfully\n");
				state = SEND_STATE;
			}
			else
			{	state = ERROR_STATE;
			}
		}
		else
		if (strncmp(buf, "QUIT", 4) == 0)
		{
			hprintf(new_fd, "221 OK, Goodbye\n");
			state = EXIT_STATE;
		}
		else
		if (strncmp(buf, "RESE", 4) == 0)
		{
			hprintf(new_fd, "250 RESET OK\n");
			state = LOGIN_STATE;
		}
		else
		if (strncmp(buf, "HELP", 4) == 0)
		{
			hprintf(new_fd, "214 PAGE <Pager ID>\n");
			hprintf(new_fd, "214 MESS <Alpha or Numeric Message>\n");
			hprintf(new_fd, "214 SEND\n");
			hprintf(new_fd, "214 QUIT\n");
			hprintf(new_fd, "250 End of Help Information\n");

			state = LOGIN_STATE;
		}
		else
		{	state = ERROR_STATE;
		}

		if (state == ERROR_STATE)
		{	hprintf(new_fd, "421 Error Connection Terminated\n");
		}
	}			
}

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
int main(int argc, char *argv[])
{
	if (argc != 2)
	{	fprintf(stderr, "Usage: snpp-server port\n");
		exit(-1);
	}

	if (deamon_init() != 0)
	{	fprintf(stderr, "Failed Starting Server deamon...\n");
		exit(1);
	}

	server_main(atoi(argv[1]), gateway);
	return 0;
}

